package hexIT;

import java.lang.*;
import java.awt.*;

/**
 *  A DrawableAdapater is a simple implementation of the Drawable
 *  interface. It can be extended to make easily custom drawable
 *  objects.
 *
 * @author Marc Lanctot
 * @version 1.0
 * @last modified: Oct 6, 2003
 * @changes: comments added
 */
public class DrawableAdapter implements Drawable
{
   Image img= null;
   String imgFilename;

	/**
	 *  Creates a new drawable adapter loading the specified image
	 *  file as this drawable object's image. Supported filenames
	 *  are all those supported by ImageTools.loadImage().
	 */
   public DrawableAdapter(String new_imgFilename)
   {
      imgFilename= new_imgFilename;

      img= ImageTools.loadImage(imgFilename);
   }

	/** Creates a drawable adapter with no associated image. */
	public DrawableAdapter()
	{
		// easier for extensions
	}

	/** Get the image associated with this drawable object. */
   public Image getImage()
   {
      return img;
   }

	/** Set the image associated with this drawable object. */
   public void setImage(Image new_img)
   {
      img= new_img;
   }

	/** Set the image associated with this drawable object. */
	public void setImage(String filename)
	{
		imgFilename= filename;
      img= ImageTools.loadImage(imgFilename);
	}

}
