package hexIT;

import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 *  A test class. Contains test code. Not to be used externally.
 */
public class Test
{
	private static HexFrame hf= null;
	private static int size;

	/** Modify this method to specify any tests to be run. */
	public static void main(String[] args)
   {
      if (args == null || args.length != 2)
      {
         System.out.println("Usage: HexFrame [h|d] <size>");
         System.exit(-1);
      }

		size= Integer.parseInt(args[1]);

      if (args[0].equals("h"))
         hf= new HexFrame("my frame name", 1024, 768, HexFrame.TYPE_HEXAGONAL, size, Color.black);
      else
      {
         //h= new HexFrame("my frame name", 1024, 768, HexFrame.TYPE_DIAMOND, 4);
         System.out.println("unimplemented");
         System.exit(-1);
      }

		// place test function here
		testObject();
   }

	private static void testObject()
	{
      Drawable testobj= new DrawableAdapter("hexIT/qt3.jpg");
      hf.putObject(2,2, testobj);
      hf.getHexPanel().setHexOutlineColor(2,2, Color.blue);
      hf.getHexPanel().setHexFillColor(2,2, Color.red);

		hf.getHexPanel().setScale(true);
      hf.setVisible(true);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_NE);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_W);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_E);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_SW);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_NW);

      try { Thread.sleep(1000); } catch(Exception e) { }
      ((HexagonalHexPanel)hf.getHexPanel()).moveObject(testobj, HexagonalBoard.DIR_SE);
	}

	private static void testSurrounding()
	{
      java.util.List l= hf.getHexPanel().getBoard().getSurrounding(2, 2, 1);
      Iterator i= l.iterator();
      while (i.hasNext())
      {
         Hexagon h= (Hexagon)i.next();
         hf.getHexPanel().setHexOutlineColor(h.getHexX(), h.getHexY(), Color.green);
         hf.getHexPanel().setHexFillColor(h.getHexX(), h.getHexY(), Color.red);
      }

	}

	private static void testLOS()
	{
      java.util.List l2= hf.getHexPanel().getBoard().getLOS(2, 2, 8, 7);
      Iterator i2= l2.iterator();
      while (i2.hasNext())
      {
         Hexagon h= (Hexagon)i2.next();
         hf.getHexPanel().setHexOutlineColor(h.getHexX(), h.getHexY(), Color.green);
         hf.getHexPanel().setHexFillColor(h.getHexX(), h.getHexY(), Color.blue);
      }
	}

	private static void testExterior()
	{
      java.util.List l3= hf.getHexPanel().getBoard().getExterior();
      Iterator i3= l3.iterator();
      while (i3.hasNext())
      {
         Hexagon h= (Hexagon)i3.next();
         hf.getHexPanel().setHexOutlineColor(h.getHexX(), h.getHexY(), Color.green);
         hf.getHexPanel().setHexFillColor(h.getHexX(), h.getHexY(), Color.white);
      }
	}

	private static void testFOV()
	{
		// place random objects
		for (int j= 0; j < 10; j++)
		{
			int x,y;

			do
			{
				x= Misc.UniformRandom(0, 2*size-2);
				y= Misc.UniformRandom(0, 2*size-2);


			}
			while (!((HexagonalBoard)hf.getHexPanel().getBoard()).isValidCoord(x,y)
			         && !(x == 2 && y == 2));

			Drawable randobj= new DrawableAdapter("hexIT/qt3.jpg");
   	   hf.putObject(x,y, randobj);
		}

		java.util.List l4= hf.getHexPanel().getBoard().getFOV(2,2,-1);
      Iterator i4= l4.iterator();
      while (i4.hasNext())
      {
         Hexagon h= (Hexagon)i4.next();
         hf.getHexPanel().setHexOutlineColor(h.getHexX(), h.getHexY(), Color.green);
         hf.getHexPanel().setHexFillColor(h.getHexX(), h.getHexY(), Color.red);
      }
	}

	private static void testShortestPath()
	{
		java.util.List l4= hf.getHexPanel().getBoard().getShortestPath(2,2,4,5);
      Iterator i4= l4.iterator();
      while (i4.hasNext())
      {
         Hexagon h= (Hexagon)i4.next();
         hf.getHexPanel().setHexOutlineColor(h.getHexX(), h.getHexY(), Color.green);
         hf.getHexPanel().setHexFillColor(h.getHexX(), h.getHexY(), Color.red);
      }
	}
}
